program Phax2_
  use sep
  implicit none
  real    :: pi
  logical :: wrap

  integer :: nz,nw
  real    :: dz,dw
  real    :: oz,ow

  real, allocatable :: ff(:,:)

  integer :: sh
  real    :: ds
  integer :: iw,iz
  real    :: ww,zz,ph

  call sep_init()
  call from_param("wrap",wrap,.true.)

  call from_param("nz",nz,1); call to_history("n1",nz)
  call from_param("oz",oz,0.);call to_history("o1",oz)
  call from_param("dz",dz,1.);call to_history("d1",dz)

  call from_param("nw",nw,1); call to_history("n2",nw)
  call from_param("ow",ow,5.);call to_history("o2",ow)
  call from_param("dw",dw,1.);call to_history("d2",dw)

  call from_param("sh",sh,1)
  call from_param("ds",ds,0.0002)

  call sep_close()
  pi=4*atan(1.)

  allocate(ff(nz,nw))

  do iw=1,nw
     ww = ow + (iw-1)*dw
     ww = 2*pi * (2*ww)
     do iz=1,nz
        zz= oz+(iz-1)*dz

        ph = ww * zz * ds

        if(wrap) then
           do while(ph>pi)
              ph=ph-2*pi
           end do
           do while(ph<-pi)
              ph=ph+2*pi
           end do
        end if

        ff(iz,iw) = ph
     end do
  end do

  call sep_write(ff)

  call exit(0)
end program Phax2_
