program RayAng_
  use sep
  use utils_

  implicit none

  complex, pointer :: rays(:,:)
  real,    pointer :: x(:,:),z(:,:)
  real,    pointer :: ang(:,:)

  type(myaxis) ::at,ag
  integer      ::it,ig,j
  integer      :: sgn
  real         :: pi,gx,gz

  pi = 4*atan(1.)

  call sep_init()

  call hinaxis(at,1)
  call hinaxis(ag,2)

  call to_history("esize",4)

  call sep_close()

  allocate(rays(at%n,ag%n))
  allocate(   x(at%n,ag%n))
  allocate(   z(at%n,ag%n))
  allocate( ang(at%n,ag%n))

  call sep_read(rays)
  z=aimag(rays)
  x= real(rays)

  !! angle
  do ig=1,ag%n
     do it=1,at%n-1
        gx = x(it+1,ig)-x(it,ig)
        gz = z(it+1,ig)-z(it,ig)

        ang(it,ig) = atan(gx/gz)
        ang(it,ig) = ang(it,ig) / pi*180.

!        if(gz<0) then
!           ang(it,ig) = ang(it,ig) + 180
!        end if

     end do
  end do
  ang(at%n,:) = ang(at%n-1,:)

  where (ang<0.)
     ang=ang+180.
  end where

  call sep_write(ang)

  call exit(0)
end program RayAng_









