program WEImvabor_main  
  use sep 
  use wei_util 
  use wei_par 
  use wei_pro 
  use wei_tag 
  use wei_mva 
  use oc_global_mod 
  use oc_utils_mod 
  use oc_solver_mod 
  use oc_cgstep_mod 
  use oc_dottest_mod 
  use weiop_cig 
  use weiop_pwc 
  use weiop_slo 
  use weiop_ssf 
  use weiop_wem 
  use weiop_bor 

  implicit none
  character(len=3) :: operation
  integer :: stat 

  real               :: ocmaxmem
  integer            :: ocniter
  logical            :: ocverb,ocmovie 
  character(len=128) :: res_, name 

  !----------------------------------------------------------------
  call sep_init()
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  !----------------------------------------------------------------
  call weipar_init()
  call weipar_report()
  call weitag_init()
  call weitag_report()
  call weipro_init()

  call from_param("operation",operation,'sca')
  call from_param("ocmaxmem",ocmaxmem,     0.)
  call from_param("ocniter", ocniter ,     1 )
  call from_param("ocverb",  ocverb  ,.false.)
  call from_param("ocmovie", ocmovie ,.false.)

  !----------------------------------------------------------------
  call weimva_init(SLin=weiop_slo1_init &
  ,                WCin=weiop_pwc0_init &
  ,                SCin=weiop_bor1_init &
  ,                FKin=weiop_wem3_init &
  ,                FXin=weiop_ssf3_init &
  ,                IGin=weiop_hcig_init )
  call weipro_report()
  !----------------------------------------------------------------
  !! select an operation
  select case(operation(1:3))
  case('dot')
     if(wpro%verb) call weimessage("start dottest")
     call oc_dottest_init(maxmem=nint(ocmaxmem))
     call oc_dottest(weimva,wtag%dS,wtag%dR &
     ,           op1=weiop_slo1 &
     ,           op2=weiop_pwc0 &
     ,           op3=weiop_bor1 &
     ,           op4=weiop_wem3 &
     ,           op5=weiop_ssf3 &
     ,           op6=weiop_hcig )
     if(wpro%verb) call weimessage("OK")
  case('mva','sca')
     if(wpro%verb) then
        if(wpro%adj) then
           call weimessage("start adjoint operator")
        else
           call weimessage("start forward operator")
        end if
     end if
     stat = weimva(wpro%adj,wpro%add,wtag%dS,wtag%dR &
     ,              SLop=weiop_slo1 &
     ,              WCop=weiop_pwc0 &
     ,              SCop=weiop_bor1 &
     ,              FKop=weiop_wem3 &
     ,              FXop=weiop_ssf3 &
     ,              IGop=weiop_hcig )
     if(wpro%verb) call weimessage("OK")
  case('inv')
     if(wpro%verb) call weimessage("start inversion")

     !! create data residual file
     name = '_res'; res_ = oc_allocate(.false.,name)
     call auxputch("n1","i",ocniter,trim(res_))
     call auxputch("esize","i",4,trim(res_))

     call oc_solver_init(ocniter,nint(ocmaxmem),ocverb,ocmovie,ocmovie)
     call oc_solver(weimva,oc_cgstep,wtag%dS,wtag%dR &
     ,           op1=weiop_slo1 &
     ,           op2=weiop_pwc0 &
     ,           op3=weiop_bor1 &
     ,           op4=weiop_wem3 &
     ,           op5=weiop_ssf3 &
     ,           op6=weiop_hcig ) 
     if(wpro%verb) call weimessage("OK")
  case default
     call seperr('unknown operation')
  end select
  !----------------------------------------------------------------  
  call exit(0)
end program WEImvabor_main
