module intp1d_
  use utils_
  implicit none

  type(myaxis),private     :: a1,b1
  integer,     private     :: ns1
contains
  !----------------------------------------------------------------
  subroutine sint1_init(  ns1_in,a1_in,b1_in)
    integer, intent(in):: ns1_in
    type(myaxis)       :: a1_in,b1_in

    a1=a1_in
    b1=b1_in



    ns1=ns1_in
    call printaxis(a1)
    call printaxis(b1)
  end subroutine sint1_init
  !----------------------------------------------------------------
  subroutine sint1(  da,   db)
    real, pointer :: da(:),db(:)

    real    :: xa1,xb1
    integer :: ia1,ib1,jb1
    real    :: x1,sincx1

    do ia1=1,a1%n
       write(0,*) ia1,a1%n
       xa1=a1%o+(ia1-1)*a1%d
       ib1=(xa1-b1%o)/b1%d+1
       if(ib1<   1+ns1) cycle
       if(ib1>b1%n-ns1) cycle

       do jb1=ib1-ns1,ib1+ns1
          xb1=b1%o+(jb1-1)*b1%d
          x1=xb1-xa1
          if(abs(x1)<epsilon(x1)) then
             sincx1 = 1.0
          else
             x1 = x1 / b1%d
             sincx1 = sin(x1)/x1
          end if

          db(jb1) = db(jb1) + da(ia1)*sincx1
       end do

    end do
  end subroutine sint1
  !----------------------------------------------------------------
end module intp1d_























