module intp2d_
  use utils_
  implicit none

  type(myaxis),private     :: a1,b1,a2,b2
  integer,     private     :: ns1,ns2
  real,        private     :: dr
contains
  !----------------------------------------------------------------
  subroutine sint2_init(  ns1_in,ns2_in,a1_in,b1_in,a2_in,b2_in)
    integer, intent(in):: ns1_in,ns2_in
    type(myaxis)       :: a1_in,b1_in,a2_in,b2_in

    a1=a1_in
    b1=b1_in
    a2=a2_in
    b2=b2_in

    ns1=ns1_in
    ns2=ns2_in
    call printaxis(a1)
    call printaxis(a2)
    call printaxis(b1)
    call printaxis(b2)

    dr=sqrt(b1%d**2 + b2%d**2)

  end subroutine sint2_init
  !----------------------------------------------------------------
  subroutine sint2(  da,     db)
    real, pointer :: da(:,:),db(:,:)

    real    :: xa1,xb1,xa2,xb2
    integer :: ia1,ib1,jb1
    integer :: ia2,ib2,jb2
    real    :: dx1,dx2,r,sincr

    do ia2=1,a2%n
       xa2=a2%o+(ia2-1)*a2%d
       ib2=(xa2-b2%o)/b2%d+1
       if(ib2<   1+ns2) cycle
       if(ib2>b2%n-ns2) cycle
       do ia1=1,a1%n
          write(0,*) ia1,a1%n,ia2,a2%n
          xa1=a1%o+(ia1-1)*a1%d
          ib1=(xa1-b1%o)/b1%d+1
          if(ib1<   1+ns1) cycle
          if(ib1>b1%n-ns1) cycle

          do jb2=ib2-ns2,ib2+ns2
             xb2=b2%o+(jb2-1)*b2%d
             dx2=xb2-xa2

             do jb1=ib1-ns1,ib1+ns1
                xb1=b1%o+(jb1-1)*b1%d
                dx1=xb1-xa1

                r=sqrt(dx1**2 + dx2**2)
                if(abs(r)<epsilon(r)) then
                   sincr = 1.0
                else
                   r = r / dr
                   sincr = sin(r)/r
                end if

                db(jb1,jb2) = db(jb1,jb2) + da(ia1,ia2)*sincr
             end do
          end do

       end do
    end do
  end subroutine sint2
  !----------------------------------------------------------------
end module intp2d_
